var _ = require('underscore')
var cheerio = require('cheerio')
var extractor = require('article-extractor')
var fs = require('fs')
var slugs = require('slugs')
var moment = require('moment')

Fetcher = function(opts) {

  extractor.extractData(opts.url, function (err, response) {

    console.log('Extracted article: ' + response.title)

    // Save Article
    var html = '<h1>' + response.title + '</h1>'
    html += '<hr>'
    html += response.content
    html += '<hr>'
    html += '<em><a href="' + opts.url + '" target="_blank">Original source</a>'
    html += 'via <a href="' + response.domain + '" target="_blank">' + response.domain + '</a></em>'

    var filename = slugs(response.title) + '.html'

    fs.writeFile('articles/html/' + filename, html, function (err) {
    	if (err) {
        return console.log(err)
      } else {
      	console.log('Saved article as: ' + filename)
      }
    })

    var description = $ = cheerio.load(response.content).text()
    console.log(description)

    // Add to Datapackage
    var article_data = {
      filename: filename,
      title: response.title,
      description: description,
      source_url: opts.url,
      domain: response.domain,
      date_archived: moment().format('YYYY-MM-DD')
    }

    var entry_csv = 'uncategorized.csv'
    var entry_data = _.values(article_data).join(',');

    fs.appendFile('articles/' + entry_csv, entry_data, function (err) {
      if (err) throw err;
      console.log('Added entry to: ' + entry_csv)
    })

    return true
  })
}

module.exports = Fetcher
